/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCachedURLResponse;

import dwt.internal.cocoa.NSData;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSURLResponse;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCachedURLResponse : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSData data ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_data);
        return result !is null ? new NSData(result) : null;
    }

    public NSCachedURLResponse initWithResponse_data_ (NSURLResponse response, NSData data)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithResponse_1data_1, response !is null ? response.id_ : null,
                data !is null ? data.id_ : null);
        return result !is null ? this : null;
    }

    public NSCachedURLResponse initWithResponse_data_userInfo_storagePolicy_ (NSURLResponse response, NSData data, NSDictionary userInfo,
            objc.id storagePolicy)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithResponse_1data_1userInfo_1storagePolicy_1, response !is null ? response.id_ : null,
                data !is null ? data.id_ : null, userInfo !is null ? userInfo.id_ : null, storagePolicy);
        return result !is null ? this : null;
    }

    public NSURLResponse response ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_response);
        return result !is null ? new NSURLResponse(result) : null;
    }

    public objc.id storagePolicy ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_storagePolicy);
    }

    public NSDictionary userInfo ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_userInfo);
        return result !is null ? new NSDictionary(result) : null;
    }

}
