/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCountedSet;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSEnumerator;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSMutableSet;
import dwt.internal.cocoa.NSSet;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCountedSet : NSMutableSet
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void addObject (id object)
    {
        OS.objc_msgSend(this.id_, OS.sel_addObject_1, object !is null ? object.id_ : null);
    }

    public NSUInteger countForObject (id object)
    {
        return cast(NSUInteger) OS.objc_msgSend(this.id_, OS.sel_countForObject_1, object !is null ? object.id_ : null);
    }

    public NSCountedSet initWithSet (NSSet set)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithSet_1, set !is null ? set.id_ : null);
        return result !is null ? this : null;
    }

    public NSEnumerator objectEnumerator ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_objectEnumerator);
        return result !is null ? new NSEnumerator(result) : null;
    }

    public void removeObject (id object)
    {
        OS.objc_msgSend(this.id_, OS.sel_removeObject_1, object !is null ? object.id_ : null);
    }

}
