/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSCustomImageRep;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSImageRep;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSCustomImageRep : NSImageRep
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id delegatee ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_delegate);
        return result !is null ? new id(result) : null;
    }

    public objc.SEL drawSelector ()
    {
        return cast(objc.SEL) OS.objc_msgSend(this.id_, OS.sel_drawSelector);
    }

    public NSCustomImageRep initWithDrawSelector (char[] aMethod, id anObject)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithDrawSelector_1delegate_1, aMethod, anObject !is null ? anObject.id_ : null);
        return result !is null ? this : null;
    }

}
