/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSDistantObjectRequest;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSConnection;
import dwt.internal.cocoa.NSException;
import dwt.internal.cocoa.NSInvocation;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSDistantObjectRequest : NSObject
{
    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSConnection connection ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_connection);
        return result !is null ? new NSConnection(result) : null;
    }

    public id conversation ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_conversation);
        return result !is null ? new id(result) : null;
    }

    public NSInvocation invocation ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_invocation);
        return result !is null ? new NSInvocation(result) : null;
    }

    public void replyWithException (NSException exception)
    {
        OS.objc_msgSend(this.id_, OS.sel_replyWithException_1, exception !is null ? exception.id_ : null);
    }
}
