/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSEnumerator;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

struct NSFastEnumerationState
{
    uint state;
    objc.id* itemsPtr;
    uint* mutationsPtr;
    /*unsigned long extra[5];*/ uint* extra;
}

public class NSEnumerator : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray allObjects ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_allObjects);
        return result !is null ? new NSArray(result) : null;
    }

    public id nextObject ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_nextObject);
        return result !is null ? new id(result) : null;
    }

}
