/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSInvocationOperation;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInvocation;
import dwt.internal.cocoa.NSOperation;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSInvocationOperation : NSOperation
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initWithInvocation (NSInvocation inv)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithInvocation_1, inv !is null ? inv.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public id initWithTarget (id target, objc.SEL sel, id arg)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithTarget_1selector_1object_1, target !is null ? target.id_ : null, sel,
                arg !is null ? arg.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public NSInvocation invocation ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_invocation);
        return result !is null ? new NSInvocation(result) : null;
    }

    public id result ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_result);
        return result !is null ? new id(result) : null;
    }

}
