/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSOpenGLPixelBuffer;

import dwt.internal.cocoa.gl;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSOpenGLPixelBuffer : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSOpenGLPixelBuffer initWithTextureTarget (GLenum target, GLenum format, GLint maxLevel, GLsizei pixelsWide, GLsizei pixelsHigh)
    {
        objc.id result = OS.objc_msgSend(this.id_,
                OS.sel_initWithTextureTarget_1textureInternalFormat_1textureMaxMipMapLevel_1pixelsWide_1pixelsHigh_1, target, format, maxLevel,
                pixelsWide, pixelsHigh);
        return result !is null ? this : null;
    }

    public GLsizei pixelsHigh ()
    {
        return cast(GLsizei) OS.objc_msgSend(this.id_, OS.sel_pixelsHigh);
    }

    public GLsizei pixelsWide ()
    {
        return cast(GLsizei) OS.objc_msgSend(this.id_, OS.sel_pixelsWide);
    }

    public GLenum textureInternalFormat ()
    {
        return cast(GLenum) OS.objc_msgSend(this.id_, OS.sel_textureInternalFormat);
    }

    public GLint textureMaxMipMapLevel ()
    {
        return cast(GLint) OS.objc_msgSend(this.id_, OS.sel_textureMaxMipMapLevel);
    }

    public GLenum textureTarget ()
    {
        return cast(GLenum) OS.objc_msgSend(this.id_, OS.sel_textureTarget);
    }

}
