/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPDFImageRep;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSData;
import dwt.internal.cocoa.NSImageRep;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPDFImageRep : NSImageRep
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSData PDFRepresentation ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_PDFRepresentation);
        return result !is null ? new NSData(result) : null;
    }

    public NSRect bounds ()
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_bounds);
        return result;
    }

    public NSInteger currentPage ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_currentPage);
    }

    public static id imageRepWithData (NSData pdfData)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSPDFImageRep, OS.sel_imageRepWithData_1, pdfData !is null ? pdfData.id_ : null);
        return result !is null ? new id(result) : null;
    }

    public NSPDFImageRep initWithData (NSData pdfData)
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_initWithData_1, pdfData !is null ? pdfData.id_ : null);
        return result !is null ? this : null;
    }

    public NSInteger pageCount ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_pageCount);
    }

    public void setCurrentPage (NSInteger page)
    {
        OS.objc_msgSend(this.id_, OS.sel_setCurrentPage_1, page);
    }

}
