/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSearchField;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSTextField;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSSearchField : NSTextField
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray recentSearches ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_recentSearches);
        return result !is null ? new NSArray(result) : null;
    }

    public NSString recentsAutosaveName ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_recentsAutosaveName);
        return result !is null ? new NSString(result) : null;
    }

    public void setRecentSearches (NSArray searches)
    {
        OS.objc_msgSend(this.id_, OS.sel_setRecentSearches_1, searches !is null ? searches.id_ : null);
    }

    public void setRecentsAutosaveName (NSString string)
    {
        OS.objc_msgSend(this.id_, OS.sel_setRecentsAutosaveName_1, string !is null ? string.id_ : null);
    }

}
