/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSShadow;

import dwt.internal.cocoa.CGFloat;
import dwt.internal.cocoa.NSColor;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSSize;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSShadow : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void set ()
    {
        OS.objc_msgSend(this.id_, OS.sel_set);
    }

    public void setShadowBlurRadius (CGFloat val)
    {
        OS.objc_msgSend(this.id_, OS.sel_setShadowBlurRadius_1, val);
    }

    public void setShadowColor (NSColor color)
    {
        OS.objc_msgSend(this.id_, OS.sel_setShadowColor_1, color !is null ? color.id_ : null);
    }

    public void setShadowOffset (NSSize offset)
    {
        OS.objc_msgSend(this.id_, OS.sel_setShadowOffset_1, offset);
    }

    public CGFloat shadowBlurRadius ()
    {
        return cast(CGFloat) OS.objc_msgSend_fpret(this.id_, OS.sel_shadowBlurRadius);
    }

    public NSColor shadowColor ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_shadowColor);
        return result !is null ? new NSColor(result) : null;
    }

    public NSSize shadowOffset ()
    {
        NSSize result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_shadowOffset);
        return result;
    }

}
