/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSpeechRecognizer;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSSpeechRecognizer : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool blocksOtherRecognizers ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_blocksOtherRecognizers) !is null;
    }

    public NSArray commands ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_commands);
        return result !is null ? new NSArray(result) : null;
    }

    public id delegatee ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_delegate);
        return result !is null ? new id(result) : null;
    }

    public NSString displayedCommandsTitle ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_displayedCommandsTitle);
        return result !is null ? new NSString(result) : null;
    }

    public bool listensInForegroundOnly ()
    {
        return OS.objc_msgSend(this.id_, OS.sel_listensInForegroundOnly) !is null;
    }

    public void setBlocksOtherRecognizers (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setBlocksOtherRecognizers_1, flag);
    }

    public void setCommands (NSArray commands)
    {
        OS.objc_msgSend(this.id_, OS.sel_setCommands_1, commands !is null ? commands.id_ : null);
    }

    public void setDelegate (id anObject)
    {
        OS.objc_msgSend(this.id_, OS.sel_setDelegate_1, anObject !is null ? anObject.id_ : null);
    }

    public void setDisplayedCommandsTitle (NSString title)
    {
        OS.objc_msgSend(this.id_, OS.sel_setDisplayedCommandsTitle_1, title !is null ? title.id_ : null);
    }

    public void setListensInForegroundOnly (bool flag)
    {
        OS.objc_msgSend(this.id_, OS.sel_setListensInForegroundOnly_1, flag);
    }

    public void startListening ()
    {
        OS.objc_msgSend(this.id_, OS.sel_startListening);
    }

    public void stopListening ()
    {
        OS.objc_msgSend(this.id_, OS.sel_stopListening);
    }

}
