/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSTableHeaderView;

import dwt.internal.cocoa.CGFloat;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSPoint;
import dwt.internal.cocoa.NSRect;
import dwt.internal.cocoa.NSTableView;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSTableHeaderView : NSView
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSInteger columnAtPoint (NSPoint point)
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_columnAtPoint_1, point);
    }

    public NSInteger draggedColumn ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_draggedColumn);
    }

    public CGFloat draggedDistance ()
    {
        return cast(CGFloat) OS.objc_msgSend_fpret(this.id_, OS.sel_draggedDistance);
    }

    public NSRect headerRectOfColumn (NSInteger column)
    {
        NSRect result;
        OS.objc_msgSend_stret(&result, this.id_, OS.sel_headerRectOfColumn_1, column);
        return result;
    }

    public NSInteger resizedColumn ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id_, OS.sel_resizedColumn);
    }

    public void setTableView (NSTableView tableView)
    {
        OS.objc_msgSend(this.id_, OS.sel_setTableView_1, tableView !is null ? tableView.id_ : null);
    }

    public NSTableView tableView ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_tableView);
        return result !is null ? new NSTableView(result) : null;
    }

}
