/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSToolbarItemGroup;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSToolbarItem;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSToolbarItemGroup : NSToolbarItem
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void setSubitems (NSArray subitems)
    {
        OS.objc_msgSend(this.id_, OS.sel_setSubitems_1, subitems !is null ? subitems.id_ : null);
    }

    public NSArray subitems ()
    {
        objc.id result = OS.objc_msgSend(this.id_, OS.sel_subitems);
        return result !is null ? new NSArray(result) : null;
    }

}
